#/usr/bin/env perl
use strict;
use warnings;
use diagnostics;
use JSON;
use Module::Reload;
use threads;
use feature "say";

my $jsonconf = "";
open(my $config, "<", "config.json");
foreach (<$config>)
{
    $jsonconf .= $_;
}
close $config;
$config = decode_json $jsonconf;

my $modules = $config -> {"modules"};

foreach (@$modules)
{
    my $fullname = "csbot2::$_";
    eval "use modules::$_";
    die("Cannot load $_ : $@") if $@;
    #say $_;
    $fullname -> init();
}

$|++; # enable autoflushing

my $irc;
my $server = $config -> {"config"} -> {"server"};
my $port = $config -> {"config"} -> {"port"};
my $nick = $config -> {"config"} -> {"nick"};
my $channels = $config -> {"config"} -> {"channels"};
my $password = $config -> {"config"} -> {"password"};
my $masters = $config -> {"config"} -> {"masters"};
my $ignore = $config -> {"config"} -> {"ignore"};
my $version = "0.2.6 now with slightly better module loading!";

if ($config -> {"config"} -> {"ssl"} == 1)
{
    eval "use IO::Socket::SSL";
    $irc = IO::Socket::SSL -> new (
    PeerAddr => $server,
    PeerPort => $port,
    Proto => "tcp"
    ) or die "Couldn't connect to IRC: $!";
}
else
{
    eval "use IO::Socket::INET";
    $irc = IO::Socket::INET -> new (
        PeerAddr => $server,
        PeerPort => $port,
        Proto => "tcp"
    ) or die "Couldn't connect to IRC: $!";
}

my ($nick_s, $user_s, $host, $chan) = ("", "", "", "");

# USER non è nick!!
say $irc "USER ", $nick, " 0 * :CounterStrikeBot strikes again";
say $irc "NICK ", $nick;

while (<$irc>)
{
    print;
    ($nick_s, $user_s, $host, $chan) = ($1, $2, $3, $4) if /^:([^\s]+)!~?([^\s]+)@([^\s]+) PRIVMSG ([^\s]+)/;

    say $irc "QUIT :bb madafackas" if $nick_s ~~ $masters and /^[^\s]+ PRIVMSG ${chan} :gtfo.*\b${nick}\b/i;

    say $irc "PRIVMSG $chan :$version" if /^:(.+?)!.+?@.+? PRIVMSG ${chan} :.*\b?${nick} version.*$/i;

    say $irc "PONG :", $1 if /^PING :(.+)$/i;

    next if $nick_s ~~ $ignore;

    if (/^:[^\s]+ (?:422|376)/) {
        say $irc "PRIVMSG NickServ :identify ", $password;
        foreach my $ch (@$channels)
        {
            say $irc "JOIN ", $ch;
        }
    }

    if (/^:(.+?)!.+?@.+? PRIVMSG ${chan} :moduleload (\w+?)\s+?$/i)
    {
        if ($nick_s ~~ $masters and not $2 ~~ $modules)
        {
            my $fullname = "csbot2::$2";
            eval "use modules::$2; $fullname -> init()";

            if ($@)
            {
                say $irc "PRIVMSG $chan :Cannot load $2 : $@";
            }
            else
            {
                push(@$modules, $2);
                say $irc "PRIVMSG $chan :Module $2 successfully loaded";
            }
        }
        else
        {
            say $irc "PRIVMSG $chan :You are not authorized to do that // The module is already loaded";
        }
    }

    if (/^:(.+?)!.+?@.+? PRIVMSG ${chan} :moduleunload (\w+?)\s+?$/i)
    {
        if ($nick_s ~~ $masters and $2 ~~ $modules)
        {
            my $fullname = "csbot2::$2";
            eval "no modules::$2; Module::Reload -> check;";
            die("Cannot unload $2 : $@") if $@;
            @$modules = grep {$_ !~ $2} @$modules;
            say $irc "PRIVMSG $chan :Module $2 successfully unloaded";
        }
    }

    say $irc "PRIVMSG ${chan} :Loaded modules: " . join(", ", @$modules) if /^:(.+?)!.+?@.+? PRIVMSG ${chan} :modulelist/i;

    foreach my $name (@$modules)
    {
        my $mod = "csbot2::$name";
        #threads->create (sub { $mod->parse ($_, $irc, $config, $chan, $nick); })->detach;
        $mod->parse ($_, $irc, $config, $chan, $nick);
    }

    ($nick_s, $user_s, $host) = ("", "", "");
}
